clear all

f = @(x) 1-(x<=0);
u = @(x) (x<=0) .*(0.25*x+0.25) + (x>0).*(-0.5*x.^2+0.25.*x+0.25);

% f = @(x) 1; 
% u = @(x) -0.5*x.^2 + 1/2;
% 
% f = @(x)  sin(4*pi*x); 
% u = @(x)  sin(4*pi*x)/16/pi^2;
% 
f = @(x) -(2*(3*x.^2-1))./(1+x.^2).^3;
u = @(x) 1./(1+x.^2)-1/2;

xplot = linspace(-1,1,500);
yplot = u(xplot);



n = 2.^(2:9)-1;
for k = 1:numel(n)
  [uh_hat,xi_hat,err_hat(k)] = fem_hat(n(k), -1,1, f,u);
%   figure(1); clf
%   plot(xi_hat,uh_hat,'r', xplot,yplot,'b');
end

n_sine = 2.^(2:7);
for k = 1:numel(n_sine)
  [uh_sin,xi_sin, err_sin(k)] = fem_sine(n_sine(k), -1,1, f,u);
%   figure(2); clf
%   plot(xi_sin,uh_sin,'r', xplot,yplot,'b');
end

n_lob = 2.^(2:7);
for k = 1:numel(n_lob)
  [uh_lob,xi_lob, err_lob(k)] = fem_lobatto(n_lob(k), -1,1, f,u);
%   figure(3); clf
%   plot(xi_lob,uh_lob,'r', xplot,yplot,'b');
end

figure(4); clf
loglog(n+1,err_hat,'-dr', n_sine, err_sin,'-ob', n_lob, err_lob, '-m*')
hold on
loglogTriangle(10,500,0.01,2,'u')
loglogTriangle(20,200,0.00005,2.5,'l')